<?php
	require_once('sql.class.php');
	class Group implements JsonSerializable {
		public $smf;
		public $id;
		public $name;
		public $description;
		public $colour;
		public $group_type;
		public $id_parent;
		public function __construct($id,$smf){
			global $db_prefix;
			$this->smf = $smf;
			$this->id = $id;
			$group = $smf->sql->query("
				SELECT	group_name as name,
						description,
						IFNULL(online_color,'black') as colour,
						group_type,
						id_parent
				FROM {$db_prefix}membergroups
				WHERE id_group = ?;
			",'i',$id)->assoc_result;
			if($group){
				foreach($group as $k => $v){
					$this->$k = $v;
				}
			}
		}
		public function jsonSerialize(){
			$members = array();
			foreach($this->members as $member){
				array_push($members,array(
					'id'=>intval($member->id),
					'name'=>$member->name,
					'real_name'=>$member->real_name
				));
			}
			return array(
				'id'=>intval($this->id),
				'name'=>$this->name,
				'description'=>$this->description,
				'colour'=>$this->colour,
				'members'=>$members
			);
		}
		public function __toString(){
			return "[Group {$this->id}] {\n  Name: {$this->name}\n  Colour: {$this->colour}\n}";
		}
		public function __get($name){
			global $db_prefix;
			switch($name){
				case 'members':
					$a = $this->smf->sql->query("
						SELECT id_member AS id
						FROM {$db_prefix}members
						WHERE id_group = ?
						OR FIND_IN_SET(?,additional_groups) <> 0;
					",'ii',$this->id,$this->id)->assoc_results;
					foreach($a as $k => $v){
						$a[$k] = $v['id'];
					}
					$a = array_unique($a);
					$r = array();
					foreach($a as $id){
						array_push($r,$this->smf->member($id));
					}
					return $r;
				break;
				case 'color':
					return $this->colour;
				break;
			}
		}
		public function permission($member=null){
			if(is_null($member)){
				$member = $this->smf->current_user;
			}elseif(!$member instanceof Member){
				$member = $this->smf->member($member);
			}
			return in_array($member->group_ids,$this->id);
		}
	}
?>
