<?php
	require_once('sql.class.php');
	class Page implements JsonSerializable{
		public $smf;
		public $id;
		public $name;
		public $type;
		public $title;
		public $body;
		public $status;
		public $group_id_string;
		public function __construct($id,$smf){
			global $db_prefix;
			$this->smf = $smf;
			$this->id = $id;
			$page = $smf->sql->query("
				SELECT	page_name as name,
						type,
						title,
						body,
						status,
						permissions as group_id_string
				FROM {$db_prefix}dp_dream_pages p
				WHERE p.id_page = ?;
			",'i',$id)->assoc_result;
			if($page){
				foreach($page as $k => $v){
					$this->$k = $v;
				}
			}
		}
		public function jsonSerialize(){
			$groups = array();
			foreach($this->groups as $group){
				array_push($groups,array(
					'id'=>intval($group->id),
					'name'=>utf8_encode($group->name)
				));
			}
			return array(
				'id'=>intval($this->id),
				'name'=>$this->name,
				'type'=>$this->type,
				'title'=>utf8_encode($this->title),
				'status'=>$this->status,
				'html'=>utf8_encode($this->html),
				'groups'=>$groups
			);
		}
		public function __toString(){
			return "[Page {$this->id}] {\n  Name: {$this->name}\n  Title: {$this->title}\n}";
		}
		public function __get($name){
			global $db_prefix;
			switch($name){
				case 'html':
					switch($this->type){
						case 2:
							return $this->smf->parse_bbc($this->body);
						break;
						default:
							return $this->body;
					}
				break;
				case 'group_ids':
					return explode(',',$this->group_id_string);
				break;
				case 'groups':
					$ps = $this->group_ids;
					$a = array();
					foreach($ps as $p){
						array_push($a,$this->smf->group($p));
					}
					return $a;
				break;
			}
		}
		public function permission($member=null){
			if(is_null($member)){
				$member = $this->smf->current_user;
			}elseif(!$member instanceof Member){
				$member = $this->smf->member($member);
			}
			return $member->permission('dream_portal_page_view') && count(array_intersect($member->group_ids,$this->group_ids)) > 0;
		}
	}
?>