<?php
	require_once('sql.class.php');
	class Topic implements JsonSerializable{
		public $smf;
		public $id;
		public $is_sticky;
		public $id_board;
		public $id_first_msg;
		public $id_last_msg;
		public $id_member_started;
		public $id_member_updated;
		public $id_poll;
		public $id_previous_board;
		public $id_previous_topic;
		public $num_replies;
		public $num_views;
		public $locked;
		public $approved;
		public function __construct($id,$smf){
			global $db_prefix;
			$this->smf = $smf;
			$this->id = $id;
			$topic = $smf->sql->query("
				SELECT	is_sticky,
						id_board,
						id_first_msg,
						id_last_msg,
						id_member_started,
						id_member_updated,
						id_poll,
						id_previous_board,
						id_previous_topic,
						num_replies,
						num_views,
						locked,
						approved
				FROM {$db_prefix}topics t
				WHERE t.id_topic = ?;
			",'i',$id)->assoc_result;
			if($topic){
				foreach($topic as $k => $v){
					$this->$k = $v;
				}
			}
		}
		public function jsonSerialize(){
			return array(
				'id'=>intval($this->id),
				'subject'=>$this->subject,
				'date_created'=>$this->date_created,
				'sticky'=>intval($this->is_sticky)==1,
				'locked'=>intval($this->locked)==1,
				'board'=>array(
					'id'=>intval($this->board->id),
					'name'=>utf8_encode($this->board->name)
				),
				'member'=>array(
					'id'=>intval($this->member->id),
					'name'=>utf8_encode($this->member->name),
					'real_name'=>utf8_encode($this->member->real_name)
				),
				'views'=>$this->num_views,
				'replies'=>$this->num_replies,
				'approved'=>intval($this->approved)==1
			);
		}
		public function __toString(){
			return "[Topic {$this->id}] {\n  Subject: {$this->subject}\n  By: {$this->member->name}\n}";
		}
		public function __get($name){
			global $db_prefix;
			switch($name){
				case 'first_post':
					return $this->smf->post(intval($this->id_first_msg));
				break;
				case 'subject':
					return $this->first_post->subject;
				break;
				case 'member':
					return $this->first_post->member;
				break;
				case 'board':
					return $this->smf->board($this->id_board);
				break;
				case 'category':
					return $this->board->category;
				break;
				case 'posts':
					$posts = $this->smf->sql->query("
						SELECT	id_msg as id
						FROM {$db_prefix}messages m
						WHERE m.id_topic = ?;
					",'i',$this->id)->assoc_results;
					$a = array();
					foreach($posts as $post){
						array_push($a,$this->smf->post($post['id']));
					}
					return $a;
				break;
				case 'post_count':
					return $this->smf->sql->query("
						SELECT	count(id_msg) as posts
						FROM {$db_prefix}messages m
						WHERE m.id_topic = ?;
					",'i',$this->id)->assoc_result['posts'];
				break;
				case 'permissions':
					return $this->permissions();
				break;
				case 'last_post':
					return $this->smf->post(intval($this->id_last_msg));
				break;
				case 'visible':
					return $this->visible();
				break;
				case 'date_created':
					return $this->first_post->poster_time;
				break;
			}
		}
		public function read($member=null){
			$this->last_post->read();
		}
		public function permission($permission,$member=null){
			return $this->board->permission($permission,$member);
		}
		public function permissions($member=null){
			return $this->board->permissions($memeber);
		}
		public function visible($member=null){
			return $this->board->visible($member);
		}
	}
?>