<?php
	define('SMF_PATH', '../../');
	require_once('../SSI_eeems/smf.class.php');
	require_once('resource.class.php');
	require_once('link.class.php');

	header('Access-Control-Allow-Origin: *');

	if(empty($_GET['resource'])){
		http_response_code(400);
		header('Content-Type: application/json');
		die(json_encode([
			'code'=>400,
			'message'=>'The "resource" query parameter is required'
		]));
	}

	$subject = $_GET['resource'];
	$info = explode(':', $subject, 2);

	if(count($info) !== 2){
		http_response_code(400);
		header('Content-Type: application/json');
		die(json_encode([
			'code'=>400,
			'message'=>'Invalid resource'
		]));
	}

	$pragma = $info[0];
	$address = $info[1];

	switch($pragma){
		case 'acct':
			$smf = new SMF();
			$member = $smf->sql->query("
				SELECT	id_member
				FROM {$db_prefix}members
				WHERE email_address = ?
					AND hide_email = 0;
			", 's', $address)->assoc_result;
			if(!$member){
				$parts = explode('@', $address, 2);
				$host = $parts[1];
				$sitehost = parse_url($scripturl, PHP_URL_HOST);
				if($host == $sitehost){
					$user = $parts[0];
					$member = $smf->sql->query("
						SELECT	id_member
						FROM {$db_prefix}members
						WHERE member_name = ?;
					", 's', $user)->assoc_result;
				}
			}
			if($member){
				$member = $smf->member($member['id_member']);
			}
			if($member instanceof Member){
				$resource = new Resource($subject, [], [], [
					new Link(
						'http://webfinger.net/rel/profile-page',
						$scripturl . '?action=profile;u='.$member->id,
						[],
						[]
					),
					new Link(
						'http://webfinger.net/rel/avatar',
						$member->avatar_href,
						[],
						[]
					)
				]);
			}
		break;
	}

	if(is_null($resource)){
		http_response_code(404);
		header('Content-Type: application/json');
		die(json_encode([
			'code'=>404,
			'message'=>'Resource not found'
		]));
	}

	header('Content-Type: application/jrd+json');
	http_response_code(200);
	die(json_encode($resource));
?>
